diff --git a/src/intel/compiler/intel_nir_tcs_workarounds.c b/src/intel/compiler/intel_nir_tcs_workarounds.c
index e2b6f358c88..e06ec236abe 100644
--- a/src/intel/compiler/intel_nir_tcs_workarounds.c
+++ b/src/intel/compiler/intel_nir_tcs_workarounds.c
@@ -131,5 +131,5 @@ intel_nir_apply_tcs_quads_workaround(nir_shader *nir)
       emit_quads_workaround(&b, end_preds[i]);
    }
 
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 }
diff --git a/src/intel/vulkan/anv_nir_lower_multiview.c b/src/intel/vulkan/anv_nir_lower_multiview.c
index 18c6fe69d33..096cdf505e2 100644
--- a/src/intel/vulkan/anv_nir_lower_multiview.c
+++ b/src/intel/vulkan/anv_nir_lower_multiview.c
@@ -301,9 +301,7 @@ anv_nir_lower_multiview(nir_shader *shader, uint32_t view_mask,
       }
    }
 
-   nir_metadata_preserve(entrypoint, nir_metadata_control_flow);
-
-   return true;
+   return nir_progress(true, entrypoint, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/intel/vulkan_hasvk/anv_nir_lower_multiview.c b/src/intel/vulkan_hasvk/anv_nir_lower_multiview.c
index 00d69818b40..20a1551a644 100644
--- a/src/intel/vulkan_hasvk/anv_nir_lower_multiview.c
+++ b/src/intel/vulkan_hasvk/anv_nir_lower_multiview.c
@@ -272,7 +272,5 @@ anv_nir_lower_multiview(nir_shader *shader, uint32_t view_mask)
       }
    }
 
-   nir_metadata_preserve(entrypoint, nir_metadata_control_flow);
-
-   return true;
+   return nir_progress(true, entrypoint, nir_metadata_control_flow);
 }
diff --git a/src/mesa/state_tracker/st_nir_lower_position_invariant.c b/src/mesa/state_tracker/st_nir_lower_position_invariant.c
index 5976dd54326..dcf9b9af330 100644
--- a/src/mesa/state_tracker/st_nir_lower_position_invariant.c
+++ b/src/mesa/state_tracker/st_nir_lower_position_invariant.c
@@ -50,7 +50,5 @@ st_nir_lower_position_invariant(struct nir_shader *s, bool aos,
 
    nir_store_output(&b, result, nir_imm_int(&b, 0),
                     .io_semantics.location = VARYING_SLOT_POS);
-   nir_metadata_preserve(b.impl, nir_metadata_control_flow);
-
-   return true;
+   return nir_progress(true, b.impl, nir_metadata_control_flow);
 }
diff --git a/src/microsoft/clc/clc_nir.c b/src/microsoft/clc/clc_nir.c
index 46b9df7129a..6d4161384ac 100644
--- a/src/microsoft/clc/clc_nir.c
+++ b/src/microsoft/clc/clc_nir.c
@@ -247,12 +247,8 @@ clc_lower_printf_base(nir_shader *nir, unsigned uav_id)
          }
       }
 
-      if (progress)
-         nir_metadata_preserve(impl, nir_metadata_loop_analysis |
-                                     nir_metadata_block_index |
-                                     nir_metadata_dominance);
-      else
-         nir_metadata_preserve(impl, nir_metadata_all);
+      nir_progress(progress, impl,
+                   nir_metadata_loop_analysis | nir_metadata_block_index | nir_metadata_dominance);
    }
 
    return printf_var != NULL;
diff --git a/src/microsoft/compiler/dxil_nir.c b/src/microsoft/compiler/dxil_nir.c
index 9cdf8381289..69fa0945f2e 100644
--- a/src/microsoft/compiler/dxil_nir.c
+++ b/src/microsoft/compiler/dxil_nir.c
@@ -900,13 +900,7 @@ upcast_phi_impl(nir_function_impl *impl, unsigned min_bit_size)
       }
    }
 
-   if (progress) {
-      nir_metadata_preserve(impl, nir_metadata_control_flow);
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-   }
-
-   return progress;
+   return nir_progress(progress, impl, nir_metadata_control_flow);
 }
 
 bool
diff --git a/src/microsoft/compiler/dxil_nir_tess.c b/src/microsoft/compiler/dxil_nir_tess.c
index dc489e8b89c..6c2adec4297 100644
--- a/src/microsoft/compiler/dxil_nir_tess.c
+++ b/src/microsoft/compiler/dxil_nir_tess.c
@@ -54,7 +54,7 @@ remove_hs_intrinsics(nir_function_impl *impl)
          nir_instr_remove(instr);
       }
    }
-   nir_metadata_preserve(impl, nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 }
 
 static void
diff --git a/src/nouveau/codegen/nv50_ir_from_nir.cpp b/src/nouveau/codegen/nv50_ir_from_nir.cpp
index a00a4679fdc..eb4af297f24 100644
--- a/src/nouveau/codegen/nv50_ir_from_nir.cpp
+++ b/src/nouveau/codegen/nv50_ir_from_nir.cpp
@@ -3296,8 +3296,7 @@ nv_nir_move_stores_to_end(nir_shader *s)
             first_store = instr;
       }
    }
-   nir_metadata_preserve(impl,
-                         nir_metadata_control_flow);
+   nir_progress(true, impl, nir_metadata_control_flow);
 }
 
 unsigned
diff --git a/src/nouveau/compiler/nak_nir_lower_cf.c b/src/nouveau/compiler/nak_nir_lower_cf.c
index f8aece84bfe..0c17c31d3a3 100644
--- a/src/nouveau/compiler/nak_nir_lower_cf.c
+++ b/src/nouveau/compiler/nak_nir_lower_cf.c
@@ -436,8 +436,7 @@ lower_cf_func(nir_function *func)
       return false;
 
    if (exec_list_is_singular(&func->impl->body)) {
-      nir_metadata_preserve(func->impl, nir_metadata_all);
-      return false;
+      return nir_no_progress(func->impl);
    }
 
    nir_function_impl *old_impl = func->impl;
diff --git a/src/nouveau/compiler/nak_nir_lower_gs_intrinsics.c b/src/nouveau/compiler/nak_nir_lower_gs_intrinsics.c
index 0640abd62e5..f5518fe64a2 100644
--- a/src/nouveau/compiler/nak_nir_lower_gs_intrinsics.c
+++ b/src/nouveau/compiler/nak_nir_lower_gs_intrinsics.c
@@ -119,7 +119,7 @@ nak_nir_lower_gs_intrinsics(nir_shader *nir)
 
    append_final_primitive_nv(impl->end_block, &state);
 
-   nir_metadata_preserve(impl, nir_metadata_none);
+   nir_progress(true, impl, nir_metadata_none);
 
    return state.progress;
 }
\ No newline at end of file
diff --git a/src/nouveau/compiler/nak_nir_lower_non_uniform_ldcx.c b/src/nouveau/compiler/nak_nir_lower_non_uniform_ldcx.c
index ecd8696e5d6..c19b068f187 100644
--- a/src/nouveau/compiler/nak_nir_lower_non_uniform_ldcx.c
+++ b/src/nouveau/compiler/nak_nir_lower_non_uniform_ldcx.c
@@ -479,11 +479,6 @@ nak_nir_lower_non_uniform_ldcx(nir_shader *nir)
    /* We use block indices to determine when something is a predecessor */
    nir_metadata_require(impl, nir_metadata_block_index | nir_metadata_divergence);
 
-   if (lower_cf_list(&b, &impl->body)) {
-      nir_metadata_preserve(impl, nir_metadata_none);
-      return true;
-   } else {
-      nir_metadata_preserve(impl, nir_metadata_all);
-      return false;
-   }
+   bool progress = lower_cf_list(&b, &impl->body);
+   return nir_progress(progress, impl, nir_metadata_none);
 }
diff --git a/src/nouveau/compiler/nak_nir_mark_lcssa_invariants.c b/src/nouveau/compiler/nak_nir_mark_lcssa_invariants.c
index bd343bc543f..f0016c50b03 100644
--- a/src/nouveau/compiler/nak_nir_mark_lcssa_invariants.c
+++ b/src/nouveau/compiler/nak_nir_mark_lcssa_invariants.c
@@ -107,13 +107,9 @@ nak_nir_mark_lcssa_invariants(nir_shader *shader)
       nir_builder b = nir_builder_create(impl);
       nir_metadata_require(impl, nir_metadata_divergence);
 
-      if (lower_cf_list(&b, &impl->body)) {
-         progress = true;
-         nir_metadata_preserve(impl, nir_metadata_control_flow |
-                                     nir_metadata_divergence);
-      } else {
-         nir_metadata_preserve(impl, nir_metadata_all);
-      }
+      bool impl_progress = lower_cf_list(&b, &impl->body);
+      progress = progress | nir_progress(impl_progress, impl,
+                                         nir_metadata_control_flow | nir_metadata_divergence);
    }
 
    return progress;
diff --git a/src/panfrost/midgard/nir_fuse_io_16.c b/src/panfrost/midgard/nir_fuse_io_16.c
index 18fd962e195..d19b3740b82 100644
--- a/src/panfrost/midgard/nir_fuse_io_16.c
+++ b/src/panfrost/midgard/nir_fuse_io_16.c
@@ -88,8 +88,7 @@ nir_fuse_io_16(nir_shader *shader)
          }
       }
 
-      nir_metadata_preserve(impl,
-                            nir_metadata_control_flow);
+      nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    return progress;
diff --git a/src/panfrost/util/pan_lower_writeout.c b/src/panfrost/util/pan_lower_writeout.c
index 532c11f4e6c..1c0d623d988 100644
--- a/src/panfrost/util/pan_lower_writeout.c
+++ b/src/panfrost/util/pan_lower_writeout.c
@@ -229,9 +229,7 @@ pan_nir_lower_zs_store(nir_shader *nir)
             nir_instr_remove(&stores[i]->instr);
       }
 
-      nir_metadata_preserve(impl,
-                            nir_metadata_control_flow);
-      progress = true;
+      progress = nir_progress(true, impl, nir_metadata_control_flow);
    }
 
    return progress;
-- 
2.48.1

